/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
)

// ConnectorsAmazonAdsDataExtractorApiService ConnectorsAmazonAdsDataExtractorApi service
type ConnectorsAmazonAdsDataExtractorApiService service

type ApiAmazonAdsDataExtractorControllerActionLoadRequest struct {
	ctx                                 context.Context
	ApiService                          *ConnectorsAmazonAdsDataExtractorApiService
	amazonAdsDataExtractorConnectorForm *AmazonAdsDataExtractorConnectorForm
}

func (r ApiAmazonAdsDataExtractorControllerActionLoadRequest) AmazonAdsDataExtractorConnectorForm(amazonAdsDataExtractorConnectorForm AmazonAdsDataExtractorConnectorForm) ApiAmazonAdsDataExtractorControllerActionLoadRequest {
	r.amazonAdsDataExtractorConnectorForm = &amazonAdsDataExtractorConnectorForm
	return r
}

func (r ApiAmazonAdsDataExtractorControllerActionLoadRequest) Execute() (*Source, *http.Response, error) {
	return r.ApiService.AmazonAdsDataExtractorControllerActionLoadExecute(r)
}

/*
AmazonAdsDataExtractorControllerActionLoad Create Amazon Ads Data Extractor source

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAmazonAdsDataExtractorControllerActionLoadRequest
*/
func (a *ConnectorsAmazonAdsDataExtractorApiService) AmazonAdsDataExtractorControllerActionLoad(ctx context.Context) ApiAmazonAdsDataExtractorControllerActionLoadRequest {
	return ApiAmazonAdsDataExtractorControllerActionLoadRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return Source
func (a *ConnectorsAmazonAdsDataExtractorApiService) AmazonAdsDataExtractorControllerActionLoadExecute(r ApiAmazonAdsDataExtractorControllerActionLoadRequest) (*Source, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *Source
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ConnectorsAmazonAdsDataExtractorApiService.AmazonAdsDataExtractorControllerActionLoad")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/connectors/amazon_ads_data_extractor/create-source"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.amazonAdsDataExtractorConnectorForm
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiAmazonAdsDataExtractorControllerActionPreviewRequest struct {
	ctx                                 context.Context
	ApiService                          *ConnectorsAmazonAdsDataExtractorApiService
	amazonAdsDataExtractorConnectorForm *AmazonAdsDataExtractorConnectorForm
}

func (r ApiAmazonAdsDataExtractorControllerActionPreviewRequest) AmazonAdsDataExtractorConnectorForm(amazonAdsDataExtractorConnectorForm AmazonAdsDataExtractorConnectorForm) ApiAmazonAdsDataExtractorControllerActionPreviewRequest {
	r.amazonAdsDataExtractorConnectorForm = &amazonAdsDataExtractorConnectorForm
	return r
}

func (r ApiAmazonAdsDataExtractorControllerActionPreviewRequest) Execute() (*SuccessResponse, *http.Response, error) {
	return r.ApiService.AmazonAdsDataExtractorControllerActionPreviewExecute(r)
}

/*
AmazonAdsDataExtractorControllerActionPreview Preview the data

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAmazonAdsDataExtractorControllerActionPreviewRequest
*/
func (a *ConnectorsAmazonAdsDataExtractorApiService) AmazonAdsDataExtractorControllerActionPreview(ctx context.Context) ApiAmazonAdsDataExtractorControllerActionPreviewRequest {
	return ApiAmazonAdsDataExtractorControllerActionPreviewRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return SuccessResponse
func (a *ConnectorsAmazonAdsDataExtractorApiService) AmazonAdsDataExtractorControllerActionPreviewExecute(r ApiAmazonAdsDataExtractorControllerActionPreviewRequest) (*SuccessResponse, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *SuccessResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ConnectorsAmazonAdsDataExtractorApiService.AmazonAdsDataExtractorControllerActionPreview")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/connectors/amazon_ads_data_extractor/preview"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.amazonAdsDataExtractorConnectorForm
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
